/*COM_AddCommand('set_score', function(p, num)
	local the = tonumber(num)
	P_AddPlayerScore(p, num)
end) testing purposes*/

rawset(_G, 'PizzaTime', {
	sync = {
		hud = {
			PizzaTimeY = 0,
			PizzaTimeFlash = 1,
			PizzaTimeTimerY = 0,
			Showtime = 0,
			IntermissionSongTimer = 15*TICRATE,
			IntermissionSong = false,
			OrganizedSP = false,
			Lap2Objs = {},
			SavedPlayers = {}
		},
		ranks = {
			[0] = {
				name = 'P',
				score = 10000,
				rings = 500,
				laps = 8,
				cantbehit = true
			},
			[1] = {
				name = "S",
				score = 10000
			},
			[2] = {
				name = "A",
				score = 7500
			},
			[3] = {
				name = "B",
				score = 5000
				
			},
			[4] = {
				name = "C",
				score = 2500
			},
			[5] = {
				name = "D",
				score = 0
			}
		},
		PizzaTime = false,
		ExtremeLap = false,
		Global_Laps = 1,
		SpawnSector = nil,
		SpawnThing = nil,
		PizzaTimeSign = nil,
		LaughedLol = false,
		ShotgunGained = false,
		Practice = false,
		LapPortalExists = false,
		Pizzaface_AI = {
			mobj = nil,
			pizzaface_stun = 35 * TICRATE,
		},
		TitleCard = {
			time = 3*TICRATE,
			alpha = 10,
			alpha2 = 0
		},
		TitleCardBool = false,
		SpecialPlayers = {
			PizzaFaces = {},
			ExtremeLapper = {}
		},
		maps_with_titlecards = {
			['Greenflower Zone 1'] = {'GFZ1', "GF1TIL"},
			['Greenflower Zone 2'] = {'GFZ2', "GF2TIL"}
			-- HEY!! are you a modder wondering how to insert your own titlecards?
			-- ill put it down this way
			--table.insert(PizzaTime.sync.maps_with_titlecards, {'SMN1', 'NAMTIL'})
			-- SMN1 means Some Map Name act 1, NAMTIL is Name Titlecard
			-- the audio and name of the graphic NEEDS to be the same.
		},
		Defined = false
	},
	functions = {
		inits = {},
		checks = {},
		triggers = {},
		thinkers = {},
		tools = {},
		hooks = {}
	}
})

addHook('MapChange', function()
	PizzaTime.sync.Defined = false
end)

sfxinfo[sfx_lap2].caption = 'Ding Ding Ding!'
sfxinfo[sfx_pizzah].caption = 'Pizzaface Laughing'

G_AddGametype({
    name = "Pizza Time 2.0",
    identifier = "PIZZATIME2",
    typeoflevel = TOL_RACE,
    rules = GTR_FRIENDLY|GTR_SPAWNENEMIES|GTR_NOTITLECARD,
    intermissiontype = int_match,
    headercolor = 35,
    description = "Make your way to the end and become Pizzaface. Or if you aren't, run back to the beginning before Pizzaface gets you!"
})