addHook('ThinkFrame', function()
	if gametype ~= GT_PIZZATIME2 then return end
	if not PizzaTime.sync.Defined then return end

	local exitingCount,playerCount = PizzaTime.functions.tools.PlayerCounter()

	if not executePTHook('Before_ScoreHandling', {exitingCount,playerCount})
		if exitingCount == playerCount
			for p in players.iterate
				if p.valid and not (p.exiting) and p.pt_mode
					P_DoPlayerExit(p)
				end
			end
		else
			for p in players.iterate
				if p.valid and p.pt_mode and not p.pt_mode.can_lap and not p.spectator
					p.exiting = 0
				end
			end
		end
		executePTHook('ScoreHandling', {exitingCount,playerCount})
	end
end)