freeslot('sfx_lap2', 'sfx_pizzah',
	'sfx_tilgf1', 'sfx_tilgf2',
	'MT_PILLARJOHN', 'S_PILLARJOHN', 'S_PILLARJOHN_UHOH', 'S_PILLARJOHN_DEAD', 'SPR_JOHN', 'SPR_JOHS', 'SPR_JOHD', 'sfx_ouchie',
	'S_SHGN_BULLET', 'S_SHGN', 'MT_SHOTGUN_BULLET', 'MT_SHOTGUN', 'SPR_FRPT', 'SPR_SHGN', 'sfx_sholod', 'sfx_shosho',
	'MT_LAPPORTAL', 'S_LAPPORTAL', 'SPR_LAP2', 'sfx_portal',
	"MT_PIZZAMASK", "MT_PIZZAFACE", "S_PIZZAFACE", "S_PIZZAFACE_SPAWN", "SPR_PZAT"
)

freeslot("MT_PIZZATOWER_EXITSIGN_SPAWN")
freeslot("SPR_GSSE")
freeslot("S_EXITSPAWN_PLACEHOLDER")

states[S_EXITSPAWN_PLACEHOLDER] = {
	sprite = SPR_GSSE,
	frame = A,
	tics = -1,
}
mobjinfo[MT_PIZZATOWER_EXITSIGN_SPAWN] = {
	doomednum = 1263, //1-26-[202]3
	spawnstate = S_EXITSPAWN_PLACEHOLDER,
	spawnhealth = 1000, //gus cannot die lol
	radius = 14*FU,
	height = 26*FU,
	flags = MF_NOCLIPTHING
}

freeslot("MT_GUSTAVO_EXITSIGN")
freeslot("S_GUSTAVO_EXIT_WAIT")
freeslot("S_GUSTAVO_EXIT_FALL")
freeslot("SPR_GESF")
freeslot("S_GUSTAVO_EXIT_RALLY")
freeslot("SPR_GESR")
freeslot("S_GUSTAVO_ICE_RALLY")
freeslot("SPR_GESI")
freeslot("S_GUSTAVO_RAT_FALL")
freeslot("SPR_GERF")
freeslot("S_GUSTAVO_RAT_RALLY")
freeslot("SPR_GERR")

states[S_GUSTAVO_EXIT_WAIT] = {
	sprite = SPR_RING,
	frame = A,
	tics = -1,
}
states[S_GUSTAVO_EXIT_FALL] = {
	sprite = SPR_GESF,
	frame = A|FF_PAPERSPRITE|FF_ANIMATE,
	var1 = 3-1,
	var2 = 2,
	tics = -1,
}
states[S_GUSTAVO_EXIT_RALLY] = {
	sprite = SPR_GESR,
	frame = A|FF_PAPERSPRITE|FF_ANIMATE,
	var1 = 9-1,
	var2 = 2,
	tics = -1,
}

states[S_GUSTAVO_ICE_RALLY] = {
	sprite = SPR_GESI,
	frame = A|FF_PAPERSPRITE|FF_ANIMATE,
	var1 = 3-1,
	var2 = 1,
	tics = -1,
}

states[S_GUSTAVO_EXIT_FALL] = {
	sprite = SPR_GESF,
	frame = A|FF_PAPERSPRITE|FF_ANIMATE,
	var1 = 3-1,
	var2 = 2,
	tics = -1,
}
states[S_GUSTAVO_RAT_FALL] = {
	sprite = SPR_GERF,
	frame = A|FF_PAPERSPRITE|FF_ANIMATE,
	tics = -1,
}
states[S_GUSTAVO_RAT_RALLY] = {
	sprite = SPR_GERR,
	frame = A|FF_PAPERSPRITE|FF_ANIMATE,
	var1 = 9-1,
	var2 = 2,
	tics = -1,
}

mobjinfo[MT_GUSTAVO_EXITSIGN] = {
	doomednum = -1,
	spawnstate = S_GUSTAVO_EXIT_WAIT,
	spawnhealth = 1000, //gus cannot die lol
	radius = 14*FU,
	height = 26*FU,
	flags = MF_NOCLIPTHING
}

freeslot("MT_STICK_EXITSIGN")
freeslot("S_STICK_EXIT_WAIT")
freeslot("S_STICK_EXIT_FALL")
freeslot("SPR_SESF")
freeslot("S_STICK_EXIT_RALLY")
freeslot("SPR_SESR")

states[S_STICK_EXIT_WAIT] = {
	sprite = SPR_RING,
	frame = A,
	tics = -1,
}
states[S_STICK_EXIT_FALL] = {
	sprite = SPR_SESF,
	frame = A|FF_PAPERSPRITE|FF_ANIMATE,
	var1 = 3-1,
	var2 = 2,
	tics = -1,
}
states[S_STICK_EXIT_RALLY] = {
	sprite = SPR_SESR,
	frame = A|FF_PAPERSPRITE|FF_ANIMATE,
	var1 = 6-1,
	var2 = 2,
	tics = -1,
}

mobjinfo[MT_STICK_EXITSIGN] = {
	doomednum = -1,
	spawnstate = S_STICK_EXIT_WAIT,
	spawnhealth = 1000, //gus cannot die lol
	radius = 10*FU,
	height = 32*FU,
	flags = MF_NOCLIPTHING
}

states[S_SHGN] = {
    sprite = SPR_SHGN,
    frame = A,
    tics = -1,
    nextstate = S_SHGN
}

states[S_PILLARJOHN] = {
	sprite = SPR_JOHN,
	frame = A,
	tics = -1,
	nextstate = S_PILLARJOHN
}

states[S_PILLARJOHN_UHOH] = {
	sprite = SPR_JOHS,
	frame = A,
	tics = -1,
	nextstate = S_PILLARJOHN_UHOH
}

states[S_PILLARJOHN_DEAD] = {
	sprite = SPR_JOHD,
	frame = A,
	tics = -1,
	nextstate = S_PILLARJOHN_DEAD
}

states[S_SHGN_BULLET] = {
    sprite = SPR_FRPT,
    frame = A,
    tics = -1,
    nextstate = S_SHGN_BULLET
}

states[S_LAPPORTAL] = {
	sprite = SPR_LAP2,
	frame = FF_ANIMATE|A,
	var1 = 2,
	var2 = 2,
	tics = -1
}

states[S_PIZZAFACE_SPAWN] = {
    sprite = SPR_PZAT,
    frame = FF_ANIMATE|A,
    tics = -1,
    var1 = 15,
    var2 = 2,
    nextstate =	S_PIZZAFACE_SPAWN
}

mobjinfo[MT_PIZZAFACE] = {
	doomednum = -1,
	spawnstate = S_PIZZAFACE_SPAWN,
	spawnhealth = 1,
	speed = 24*FRACUNIT,
	radius = 60*FRACUNIT,
	height = 72*FRACUNIT,
	flags = MF_NOCLIPHEIGHT|MF_NOBLOCKMAP|MF_RUNSPAWNFUNC|MF_NOGRAVITY|MF_NOCLIP
}

mobjinfo[MT_PIZZAMASK] = {
	doomednum = -1,
	spawnstate = S_PIZZAFACE,
	spawnhealth = 1000,
	deathstate = S_NULL,
	radius = 16*FU,
	height = 48*FU,
	flags = MF_NOCLIPHEIGHT|MF_NOBLOCKMAP|MF_RUNSPAWNFUNC|MF_NOGRAVITY|MF_NOCLIP
}

mobjinfo[MT_PILLARJOHN] = {
	doomednum = -1,
	spawnstate = S_PILLARJOHN,
	spawnhealth = 2,
	deathstate = S_PILLARJOHN_DEAD,
	radius = 64*FU,
	height = 200*FU,
	flags = MF_SPECIAL|MF_ENEMY
}

mobjinfo[MT_LAPPORTAL] = {
	doomednum = 2048,
	spawnstate = S_LAPPORTAL,
	spawnhealth = 9999,
	radius = 32*FU,
	height = 130*FU,
	flags = MF_SPECIAL|MF_NOGRAVITY
}

states[S_PIZZAFACE] = {
    sprite = SPR_PZAT,
    frame = FF_ANIMATE|A,
    tics = -1,
    var1 = 15,
    var2 = 2,
    nextstate = SPR_PZAT
}

sfxinfo[sfx_sholod].caption = 'Click'
sfxinfo[sfx_shosho].caption = 'Bang!'
sfxinfo[sfx_ouchie].caption = 'BAM!'
sfxinfo[sfx_portal].caption = 'how do i explain this?'

mobjinfo[MT_SHOTGUN_BULLET] = {
	doomednum = -1,
	spawnstate = S_SHGN_BULLET,
	spawnhealth = 1,
	deathstate = S_NULL,
	xdeathstate = S_NULL,
	radius = 16*FU,
	height = 16*FU,
	flags = MF_NOGRAVITY|MF_MISSILE
}

mobjinfo[MT_SHOTGUN] = {
	doomednum = -1,
	spawnstate = S_SHGN,
	spawnhealth = 1,
	deathstate = S_NULL,
	xdeathstate = S_NULL,
	radius = 16*FU,
	height = 16*FU,
	flags = MF_NOGRAVITY|MF_NOCLIP
}

sfxinfo[sfx_lap2].caption = 'Ding Ding Ding!'
sfxinfo[sfx_pizzah].caption = 'Pizzaface Laughing'
sfxinfo[sfx_tilgf1].caption = 'Titlecard'
sfxinfo[sfx_tilgf2].caption = 'Titlecard'

rawset(_G, 'max_laps', CV_RegisterVar({name = 'pizzatime_max_normal_laps', defaultvalue = 3, flags = CV_NETVAR}))
rawset(_G, 'max_extreme_laps', CV_RegisterVar({name = 'pizzatime_max_extreme_laps', defaultvalue = 5, flags = CV_NETVAR}))
rawset(_G, 'max_extreme_rings', CV_RegisterVar({name = 'pizzatime_max_extreme_rings', defaultvalue = 120, flags = CV_NETVAR}))

rawset(_G, 'lap_3', CV_RegisterVar({name = 'pizzatime_lap_3', defaultvalue = 'Yes', flags = CV_NETVAR, PossibleValue = CV_YesNo}))
rawset(_G, 'lap_3_multi_pizzafaces', CV_RegisterVar({name = 'pizzatime_lap_3_multi_pizzafaces', defaultvalue = 'No', flags = CV_NETVAR, PossibleValue = CV_YesNo}))
rawset(_G, 'lap_3_exiting_players_become_pizzaface', CV_RegisterVar({name = 'pizzatime_lap_3_exiting_players_become_pizzaface', defaultvalue = 'No', flags = CV_NETVAR, PossibleValue = CV_YesNo}))

rawset(_G, 'defender', CV_RegisterVar({name = 'pizzatime_defender', defaultvalue = 'No', flags = CV_NETVAR, PossibleValue = CV_YesNo}))

rawset(_G, 'war_timer_time', CV_RegisterVar({name = 'pizzatime_war_timer_time', defaultvalue = 300, flags = CV_NETVAR}))
rawset(_G, 'old_war_timer', CV_RegisterVar({name = 'pizzatime_war_timer_old', defaultvalue = 'No', flags = CV_NETVAR, PossibleValue = CV_YesNo}))

dofile('HUDSHIT1.lua')

dofile('Gamemode Registry.lua')

dofile('Pizzaface.lua')
dofile('Shotgun.lua')
dofile('PFunctions.lua')
dofile('Functions.lua')
dofile('Hooks.lua')
dofile('HUDSHIT2.lua')
dofile('HUD.lua')
dofile('Music.lua')
dofile('Score Handling.lua')

dofile('LUA_thinkers.lua')