rawset(_G, 'custom_music_is_playing', false)

addHook('NetVars', function(n)
  custom_music_is_playing = n($)
end)

addHook('MapChange', function()
	custom_music_is_playing = false
end)

addHook('ThinkFrame', function()
	if gametype ~= GT_PIZZATIME2 then return end
	if not PizzaTime.sync.Defined then return end
	if executePTHook('MusicHandler', {})
		custom_music_is_playing = true
	end
	local extreme = (PizzaTime.sync.SpecialPlayers.ExtremeLapper[1] and PizzaTime.sync.SpecialPlayers.ExtremeLapper[1].valid and not PizzaTime.sync.SpecialPlayers.ExtremeLapper[1].spectator) or false
	if not extreme and not PizzaTime.sync.ShotgunGained and not custom_music_is_playing
		if PizzaTime.sync.PizzaTime and PizzaTime.sync.Global_Laps < 2 and mapmusname ~= 'PIZTIM' then
			S_ChangeMusic('PIZTIM', true)
			mapmusname = 'PIZTIM'
		end if PizzaTime.sync.PizzaTime and PizzaTime.sync.Global_Laps == 2 and mapmusname ~= 'DEAOLI' then
			S_ChangeMusic('DEAOLI', true)
			mapmusname = 'DEAOLI'
		end if PizzaTime.sync.PizzaTime and PizzaTime.sync.Global_Laps >= 3 and mapmusname ~= 'LAP3LO' then
			S_ChangeMusic('LAP3LO', true)
			mapmusname = 'LAP3LO'
		end
	elseif not PizzaTime.sync.ShotgunGained and extreme and not custom_music_is_playing
		local p = PizzaTime.sync.SpecialPlayers.ExtremeLapper[1]
		if PizzaTime.sync.PizzaTime and PizzaTime.sync.SpecialPlayers.ExtremeLapper[1]
			if p.pt_mode.war_timer.time > 35*TICRATE and mapmusname ~= 'EXTREM' then
				S_ChangeMusic('EXTREM', true)
				mapmusname = 'EXTREM'
			elseif p.pt_mode.war_timer.time <= 35*TICRATE and mapmusname ~= 'EXTTIM' then
				S_ChangeMusic('EXTTIM', false)
				mapmusname = 'EXTTIM'
			end
		end
	elseif not custom_music_is_playing and PizzaTime.sync.ShotgunGained
		if PizzaTime.sync.PizzaTime and PizzaTime.sync.ShotgunGained and mapmusname ~= 'UNEXPC'
			S_ChangeMusic('UNEXPC', true)
			mapmusname = 'UNEXPC'
		end
	end
end)