addHook('MobjThinker', function(mo)
	if mo.valid and mo.linked_mo and mo.linked_mo.valid
		local Lmo = mo.linked_mo
		P_MoveOrigin(mo, Lmo.x + (16*cos(Lmo.player.drawangle - ANGLE_90)),  Lmo.y + (16*sin(Lmo.player.drawangle - ANGLE_90)), Lmo.z + (Lmo.height / 3))
		mo.angle = Lmo.angle
	elseif not mo.linked_mo or not mo.linked_mo.valid
		P_KillMobj(mo)
	end
end, MT_SHOTGUN)

addHook('MobjMoveCollide', function(mo, mo2)
	if gametype == GT_PIZZATIME2 and PizzaTime.sync.Defined
		if L_ZCollide(mo, mo2) and ((mo2.flags & MF_SPRING) or (mo2.flags & MF_MONITOR))
			mo.player.pt_mode.shotgun.stomp = false
		end
	end
end, MT_PLAYER)

addHook('ShieldSpecial', function(p)
	if p.mo and p.mo.valid
		if p.pt_mode and p.pt_mode.shotgun and p.pt_mode.shotgun.can_use and not P_IsObjectOnGround(p.mo)
			return true
		end
	end
end)

addHook('ShouldDamage', function(t,i,s)
	if i and i.type == MT_SHOTGUN_BULLET and t.player and t.player.pt_mode and t.player.pt_mode.pizzaface then
		if s and s.player and s.player.pt_mode and s.player.pt_mode.defender then
			return true
		end
		return false
	end
end,MT_PLAYER)

addHook('PlayerCanDamage', function(p, mo)
	if p.pt_mode and p.pt_mode.shotgun.stomp and p.mo
		return true
	end
end)